# -*- coding: utf-8 -*-

import httplib

def remvalue(z):
	if isinstance(z, dict):

		# Fjerne uinteressante nøkler.
		for k in ["ind1", "ind2", "namespace"]:
			if z.has_key(k):
				del(z[k])

		# Rette opp i verdiene av value-nøkler, typisk tekst,
		# for så å fjerne som de viser seg å være tomme.
		if z.has_key("value"):
			z["value"] = z["value"].strip()
			if z["value"] == "":
				del(z["value"])

		# Fjerne unødvendig dybde som kommer av value-nøkler.
		if len(z.keys()) == 1 and z.has_key("value"):
			return remvalue(z["value"])

		# Kjøre remvalue på alle verdiene i dict.
		for k in z.keys():
			z[k] = remvalue(z[k])

                # Sikre at lister med et element fortsatt er lister.
                for k in ["datafield", "controlfield", "relationship"]:
                        if z.has_key(k):
                                t = z[k]
                                z[k] = dict()
                                if isinstance(t, dict):
                                        t = [t]
                                for e in t:

					if k == "datafield":
						z[k][e["tag"]] = dict()
						if e.has_key("subfield"):
							if isinstance(e["subfield"], dict):
								e["subfield"] = [e["subfield"]]
							for s in e["subfield"]:
								z[k][e["tag"]][s["code"]] = s["value"]
						
					if k == "controlfield":
						if e.has_key("value"):
							z[k][e["tag"]] = e["value"]

					if k == "relationship":
						if not z[k].has_key(e["type"]):
							z[k][e["type"]] = list()
						ty = e["type"]
						for l in ["type", "label", "target_type_label"]:
							if e.has_key(l):
								del(e[l])
						z[k][ty].append(e)

	if isinstance(z, list):
		# Kjøre remvalue på alle verdiene i listen.
		z = [remvalue(o) for o in z]

	if isinstance(z, str):
		# Justere presentasjon av tekst.
		z = z.replace("\t", "")
		z = " ".join([l.strip() for l in z.split("\n")])

	return z
