package net.klakegg.master.frbr

import java.util.Map;

import org.svenson.JSON;
import org.svenson.JSONParser;

class HomeController {
	
	public static cdb = "http://kangaroo.hoo9.com:5984/snb/"
	def rels = [
	            "5.2.1.1.F":"Is realized through",
	            "5.2.1.1.R":"Is a realization of",
	            "5.2.1.2.F":"Is embodied in",
	            "5.2.1.2.R":"Is the embodiment of",
	            "5.2.2.1.F":"Has created",
	            "5.2.2.1.R":"Is created by",
	            "5.2.2.2.F":"Has created",
	            "5.2.2.2.R":"Is created by",
	            "5.2.2.3.F":"Has realized",
	            "5.2.2.3.R":"Is realized by",
	            "5.2.2.4.F":"Has realized",
	            "5.2.2.4.R":"Is realized by",
	            "5.2.2.5.F":"Has produced",
	            "5.2.2.5.R":"Is produced by",
	            "5.2.3.1.F":"Is subject of",
	            "5.2.3.1.R":"Has as subject",
	            "5.2.3.10.R":"Has as subject",
	            "5.2.3.5.F":"Is subject of",
	            "5.2.3.6.F":"Is subject of",
	            "5.2.3.6.R":"Has as subject",
	            "5.2.3.7.R":"Has as subject",
	            "5.3.1.6.F":"Supplements",
	            "5.3.1.6.R":"Has as supplement",
	            "5.3.1.8.F":"Is part of",
	            "5.3.1.8.R":"Has part"]
	def types = [
	            "4.2":"Work",
	            "4.3":"Expression",
				"4.6":"Person",
	            "4.8":"Concept"
	]
	
	
    def index = { }
	
	def autocomplete =
	{
		if (params.term)
		{
			def url = cdb + "_design/frbrbackend/_view/names?limit=20&startkey=\"" + params.term + "\""
			Map json = JSONParser.defaultJSONParser().parse(Map.class, url.toURL().text)

			def r = []
			for (Map m : json.rows)
				r.add([id: m.id, name: m.key, value: m.key])
			response.outputStream << JSON.defaultJSON().forValue(r)
		}
	}
	
	def present =
	{
		if (!params.id)
			return redirect(action: "index")
		[rels:rels, types:types]
	}
}
