# -*- coding: utf-8 -*-

import sys, json, httplib, getopt, frbrutil, glob
from xml2dict.xml2dict import XML2Dict

config = dict(p=5984, h="localhost", d=None)
optlist, args = getopt.getopt(sys.argv[1:], 'p:h:d:f')

for ok, ov in optlist:
	config[ok[1:]] = ov

xml = XML2Dict()

if config.has_key("f"):
	arglist = []
	for a in args:
		arglist += glob.glob(a + "*.xml")
	args = arglist

for a in args:
	r = xml.parse(a)
	print a, len(r["collection"]["record"])
	for x in r["collection"]["record"]:
		x = frbrutil.remvalue(x)

		x["_id"] = x["id"]
		del(x["id"])

		# print json.dumps(x)

		if config["d"]:
			h = httplib.HTTPConnection(config["h"] + ":" + str(config["p"]))
			h.request("PUT", "/" + config["d"] + "/" + x["_id"], json.dumps(x))
