class UrlMappings {
	static mappings = {
		
		// HOME
		"/" (view:"/index")

		// RECORD
		"/start" (
			controller: "record", action: "start")
		"/record" (
			controller: "record", action: "record")
		"/record/event" (
			controller: "record", action: "event")
		"/record/proxy" (
			controller: "record", action: "proxy")
		"/record/task" (
			controller: "record", action: "task")
		"/record/finish" (
			controller: "record", action: "finish")
		

		// ADMIN
		"/admin" (
			controller: "admin", action: "index")

		// SUITE
		"/admin/all" (
			controller: "suite", action: "index")
		"/admin/create" (
			controller: "suite", action= "create")
		"/admin/$suite" (
			controller: "suite", action: "view")
		"/admin/$suite/edit" (
			controller: "suite", action: "edit")

		// USE CASE
		"/admin/$suite/uc" (
			controller: "usecase", action: "index")
		"/admin/$suite/uc/create" (
			controller: "usecase", action: "create")
		"/admin/$suite/uc/$id" (
			controller: "usecase", action: "view")
		"/admin/$suite/uc/$id/recs" (
			controller: "usecase", action: "recordings")

		// CODE
		"/admin/$suite/code" (
			controller: "code", action: "index")

		// REPLAY
		"/admin/replay/$id" (
			controller: "replay", action: "index")
		"/admin/replay/$id/data" (
			controller: "replay", action: "data")

		"/$controller/$action?/$id?"{
			constraints {
				// apply constraints here
			}
		}

		"500"(view:'/error')
	}
}
